Java核心类库之(异常机制)

以下博客是根据黑马视频写的Javase全集博客笔记黑马程序员全套Java教程_Java基础入门视频教程,零基础小白自学Java必备教程

(一)Java语言基础
(二)Java面向对象编程
(三)Java核心类库之(常用API、字符串类、集合类、泛型)
(四) Java核心类库之(异常机制)
(五)Java核心类库之(字符集/编码集、File类、递归、IO流:字节流、字符流、特殊操作流)
(六)Java核心类库之(类加载器、反射机制、模块化)
(七)Java核心类库之(Lambda表达式)
(八)Java核心类库之(接口组成更新、方法引用、函数式接口)
(九)Java核心类库之(Stream流:生成、中间、终结、收集操作)
(十)Java核心类库之(多线程:实现多线程、线程同步)
(十一)Java核心类库之(网络编程:网络编程入门、UDP通信程序、TCP通信程序)

1 异常

1.1 异常的概述

  • 异常:就是程序出现了不正常的情况
    在这里插入图片描述

  • Error:严重问题,不需要处理

  • Exception:称为异常类,它表示程序本身可以处理的问题

  • RuntimeException:在编译期是不检查的,出现问题后,需要我们回来修改代码

  • 非RuntimeException:编译期就必须处理的,否则程序不能通过编译,就更不能正常运行了

1.2 常见异常类型

  • 数组索引越界异常:ArrayIndexOutOfBoundsException
  • 空指针异常:NullPointerException;直接输出没有问题,但是调用空指针的变量的功能就会报错
  • 类型转换异常:ClassCastException
  • 迭代器遍历没有此元素异常:NoSuchElementException
  • 数学操作异常:ArithmeticException
  • 数子转换异常:NumberFormatException

1.3 JVM的默认处理方案

  • 如果程序出现了问题,我们没有做任何处理,最终 JVM 会做默认处理
    • 把异常的名称、异常的原因以及异常出现的位置等信息输出在控制台
    • 有异常的位置程序停止运行

1.4 编译时异常的处理方式

  • 如果程序出现了问题,我们需要自己来处理,有两种处理方案
    • try … catch …
    • throws

1.4.1 异常处理之 try … catch … [kætʃ](捕获异常)

  • 格式1
try {
	可能出现异常的代码;
} catch (异常类名 变量名) {
	异常的处理代码;
} /*catch (异常类名1 变量名1) {
	异常的处理代码;
}*/
  • 格式二
try{
    可能出现异常的代码;
} catch(Exception e){
    e.printStackTrae(); //返回异常信息
}
  • 执行流程

    • 程序从 try 里面的代码开始执行
    • 出现异常,会自动生成一个异常类对象,该异常对象将被提交给Java运行时系统
    • 当Java运行时系统接收到异常对象时,会到 catch 中 去找匹配的异常类,找到后进行异常处理
    • 执行完毕之后,程序还可以继续往下执行
  • 范例

package ceshi;

public class ExceptionDemo {
    public static void main(String[] args) {
        System.out.println("开始");
        method();
        System.out.println("结束");
    }
    public static void method() {
        try {
            int[] arr = {1, 2, 3};
            System.out.println(arr[3]); //出现异常时,会创建一个异常对象new ArrayIndexOutOfBoundsException();
        } catch (ArrayIndexOutOfBoundsException/Exception e) {
            e.printStackTrace();
            /*开始
            结束
            java.lang.ArrayIndexOutOfBoundsException: 3
            at ceshi.ExceptionDemo.method(ExceptionDemo.java:12)
            at ceshi.ExceptionDemo.main(ExceptionDemo.java:6)*/

        }
    }
}

1.4.2 异常处理之 throws(抛出异常)

  • 格式
throws 异常类名; 
  • 注意:这个格式是跟在方法的括号后面的
  • 编译时异常必须要进行处理,两种处理方案:try … catch… 或者 throws,如果采用 throws 这种方案,将来还是需要调用try … catch …
  • 运行时异常可以不处理,出现问题后,需要我们会来改代码
package ceshi;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class ExceptionDemo {
    public static void main(String[] args)  {
        System.out.println("开始");
//        method();
        try {
            method2();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        System.out.println("结束");
    }

    //编译时异常
    public static void method2() throws ParseException {
        String s = "2020-7-16";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date d = sdf.parse(s); //parse报错:ParseException
        System.out.println(d); //Thu Jul 16 00:00:00 CST 2020
    }
    
    //运行时异常
    public static void method() throws Exception{
        int[] arr = {1,2,3};
        System.out.println(arr[3]);
        /*开始
        Exception in thread "main" java.lang.ArrayIndexOutOfBoundsException: 3
        at ceshi.ExceptionDemo.method(ExceptionDemo.java:28)
        at ceshi.ExceptionDemo.main(ExceptionDemo.java:9)*/
    }
}

1.5 Throwable 的成员方法

方法名说明
public String getMessage()返回此 throwable 的详细信息字符串
public String toString()返回此可抛出的简短描述
public void printStackTrace() (常用) [treɪs]把异常的错误信息输出在控制台
package ceshi;

public class ExceptionDemo {
    public static void main(String[] args) {
        System.out.println("开始");
        method();
        System.out.println("结束");
    }
    public static void method() {
        try {
            int[] arr = {1, 2, 3};
            System.out.println(arr[3]); //出现异常时,会创建一个异常对象new ArrayIndexOutOfBoundsException();
        } catch (ArrayIndexOutOfBoundsException e) {
            //1,public String getMessage() 	返回此 throwable 的详细信息字符串
            System.out.println(e.getMessage()); //Index 3 out of bounds for length 3

            //2,public String toString() 	返回此可抛出的简短描述
            System.out.println(e.toString()); //java.lang.ArrayIndexOutOfBoundsException: 3

            //3,public void printStackTrace() (常用) 	把异常的错误信息输出在控制台
            e.printStackTrace();
            /*java.lang.ArrayIndexOutOfBoundsException: 3
            at ceshi.ExceptionDemo.method(ExceptionDemo.java:12)
            at ceshi.ExceptionDemo.main(ExceptionDemo.java:6)*/
        }
    }
}

1.6 编译时异常和运行时异常的区别

  • Java中的异常被分为两大类:编译时异常和运行时异常,也被称为受检异常和非受检异常
  • 运行时异常就是运行时才报错,编译时异常就是编译时有红线报错
    • RuntimeException类及其子类运行时异常):无需显示处理,也可以和编译时异常一样处理
    • 其余异常编译时异常):必须显示处理,否则程序就会发生错误,无法通过编译(有可能会出现异常,并不是一定会出现)

1.7 finally关键字

  • 用在捕获处理的异常格式中,放在最后面
  • 格式
try{
    //可能出现异常的代码!
}catch{Exception e}{
    e.printStackTrace();
}finally{
    // 无论代码是出现异常还是正常执行,最终一定要执行这里的代码!!
}
  • finally的作用:可以在代码执行完毕后进行资源的释放操作

  • 资源都是实现了Closeable接口的,都自带close()关闭方法

    • try : 出现1次
    • catch:出现0 - N 次(如果有finally那么 catch 可以没有)
    • finally:出现0 - 1 次

1.8 自定义异常

  • 格式
public class 异常类名 enxtends Exception {
	无参构造
	带参构造
} 
  • 异常类
package ceshi;

public class ScoreException extends Exception{
    //自动生成无参,带参构造方法
    public ScoreException() { }

    public ScoreException(String message) {
        super(message);
    }
}
  • 操作类
package ceshi;

public class Teacher {

    public void checkScore(int score) throws ScoreException {
        if(score<0 || score>100) {
            throw new ScoreException("你给的分数有误");
        } else {
            System.out.println("成绩正常");
        }
    }
}
  • 测试类
package ceshi;

import java.util.Scanner;

public class Demo {
    public static void main(String[] args)  {
        Scanner sc = new Scanner(System.in);
        System.out.println("请输入分数"); 
        int score = sc.nextInt(); //120

        Teacher t = new Teacher();
//        t.checkScore(score); //checkScore报错,编译时异常需要捕获
        try {
            t.checkScore(score);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

1.9 throws 和 throw 的区别

throws的特点

  • 用在方法声明后面,跟的是异常类名
  • 表示抛出异常,由该方法的调用者来处理
  • 表示出现异常的一种可能性,并不一定会发生这些异常

throw的特点

  • 用在方法体内,跟的是异常对象名
  • 表示抛出异常,由方法体内的语句处理
  • 执行 throw 一定抛出了某种异常

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
©️2022 CSDN 皮肤主题:博客之星2021 设计师:Hiro_C 返回首页

打赏作者

小袁ITSuper

你的鼓励将是我创作的最大动力

¥2 ¥4 ¥6 ¥10 ¥20
输入1-500的整数
余额支付 (余额:-- )
扫码支付
扫码支付:¥2
获取中
扫码支付

您的余额不足,请更换扫码支付或充值

打赏作者

实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、C币套餐、付费专栏及课程。

余额充值